const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const delayed_payments = sequelize.define(
    'delayed_payments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      amount: {
        type: DataTypes.DECIMAL,
      },

      due_date: {
        type: DataTypes.DATE,
      },

      notified: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  delayed_payments.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.delayed_payments.belongsTo(db.partners, {
      as: 'partner',
      foreignKey: {
        name: 'partnerId',
      },
      constraints: false,
    });

    db.delayed_payments.belongsTo(db.kooperatif, {
      as: 'kooperatif',
      foreignKey: {
        name: 'kooperatifId',
      },
      constraints: false,
    });

    db.delayed_payments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.delayed_payments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return delayed_payments;
};
